#!/usr/bin/env node

let fs = require('fs')
let path = require('path')
let shell = require("shelljs")
const download = require('download');
const chalk = require('chalk');
const program = require('commander');

program.name("npmdn"); // 名字介绍
program.usage("下载npm的tgz文件，并且会递归下载依赖的npm的tgz文件"); // 使用方式介绍
program.version("1.0.1"); // 版本
program.option("-nl --npmlist <items>", "需要下载的npm包名,支持字符串，数组", (val) => val.split(',')); // 参数介绍
program.option("-o --output <value>", "下载目录", '.');

const args = program.parse(process.argv);
let opts = args.opts()
console.log(chalk.bold.bgWhite.blue('npm tgz download start'))

let pack = []
opts = JSON.parse(JSON.stringify(opts))
let npmlist = opts.npmlist
if(npmlist) {
    if(Array.isArray(npmlist)) {
        pack = npmlist
    } else if(typeof opts.npmlist === 'string') {
        if(npmlist.indexOf(',') > -1) {
            pack = npmlist.splice(',')
        } else {
            pack = [npmlistS]
        }
    }
}
if(opts.output) {
    if(fs.existsSync(opts.output)) {
        console.log(chalk.bold.bgWhite.red(`${opts.output} 路径已经存在`))
    } else {
        fs.mkdirSync(opts.output)
    }
    shell.cd(opts.output)
} else {
    shell.cd('.')
}
const map = {}
pack.forEach((item, index) => {
    map[item] = {key: item, children: []}
    npmDownload(item)
})


function npmDownload(npmName) {
    let result = shell.exec(`npm view ${npmName} dist.tarball`, { async: true })
    result.stdout.on('data', async function (tgzUrl) {
       if (tgzUrl && (tgzUrl.startsWith('https://') || tgzUrl.startsWith('http://'))) {
        await download(tgzUrl, 'npm-libs')
        console.log(chalk.bold.bgWhite.red(`download ${tgzUrl} success`))
    }
    });
    const dependencies = shell.exec(`npm view ${npmName} dependencies --json`, { async: true })
    dependencies.stdout.on('data', function (dependencies) {
        if(dependencies) {
            dependencies = JSON.parse(dependencies)
            Object.keys(dependencies).forEach(async key => {
                let version = dependencies[key]
                if(version.startsWith("^")) {
                    version = version.substr(1)
                    const packageName = key + "@" + version
                    npmDownload(packageName)
                }
            })
        }
    });
}